import { LogLevel as Logs, setLogLevel as setLogs } from './misc/util';
import { TopologyEnum } from './service/topology/Topology';
import { SignalingState as SigState } from './Signaling';
import { WebChannelState } from './WebChannelState';
export { WebGroup } from './WebChannelFacade';
export function setLogLevel() {
    var levels = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        levels[_i] = arguments[_i];
    }
    setLogs(levels);
}
var SignalingState = (function () {
    function SignalingState() {
    }
    Object.defineProperty(SignalingState, "CONNECTING", {
        get: function () {
            return SigState.CONNECTING;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SignalingState, "OPEN", {
        get: function () {
            return SigState.OPEN;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SignalingState, "CLOSED", {
        get: function () {
            return SigState.CLOSED;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SignalingState, "CHECKING", {
        get: function () {
            return SigState.CHECKING;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SignalingState, "CHECKED", {
        get: function () {
            return SigState.CHECKED;
        },
        enumerable: true,
        configurable: true
    });
    return SignalingState;
}());
export { SignalingState };
var WebGroupState = (function () {
    function WebGroupState() {
    }
    Object.defineProperty(WebGroupState, "JOINING", {
        get: function () {
            return WebChannelState.JOINING;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebGroupState, "JOINED", {
        get: function () {
            return WebChannelState.JOINED;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebGroupState, "LEFT", {
        get: function () {
            return WebChannelState.LEFT;
        },
        enumerable: true,
        configurable: true
    });
    return WebGroupState;
}());
export { WebGroupState };
var Topology = (function () {
    function Topology() {
    }
    Object.defineProperty(Topology, "FULL_MESH", {
        get: function () {
            return TopologyEnum.FULL_MESH;
        },
        enumerable: true,
        configurable: true
    });
    return Topology;
}());
export { Topology };
var LogLevel = (function () {
    function LogLevel() {
    }
    Object.defineProperty(LogLevel, "DEBUG", {
        get: function () {
            return Logs.DEBUG;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LogLevel, "WEB_GROUP", {
        get: function () {
            return Logs.WEB_GROUP;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LogLevel, "WEBRTC", {
        get: function () {
            return Logs.WEBRTC;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LogLevel, "CHANNEL", {
        get: function () {
            return Logs.CHANNEL;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LogLevel, "TOPOLOGY", {
        get: function () {
            return Logs.TOPOLOGY;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LogLevel, "SIGNALING", {
        get: function () {
            return Logs.SIGNALING;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LogLevel, "CHANNEL_BUILDER", {
        get: function () {
            return Logs.CHANNEL_BUILDER;
        },
        enumerable: true,
        configurable: true
    });
    return LogLevel;
}());
export { LogLevel };
//# sourceMappingURL=index.common.doc.js.map