import { Observable } from 'rxjs';
import { Channel } from '../../Channel';
import { dataChannelBuilder as proto } from '../../proto';
import { WebChannel } from '../../WebChannel';
import { Service } from '../Service';
export declare const CONNECT_TIMEOUT = 7000;
export declare class DataChannelBuilder extends Service<proto.IMessage, proto.Message> {
    static readonly SERVICE_ID: number;
    private readonly remotes;
    private readonly channelsSubject;
    private rtcConfiguration;
    private allStreams;
    private wc;
    constructor(wc: WebChannel, rtcConfiguration: RTCConfiguration);
    onChannel(): Observable<Channel>;
    connectInternal(id: number): Promise<void>;
    connectToJoin(id: number): Promise<void>;
    connectToInvite(id: number): Promise<void>;
    clean(): void;
    private connect(streamId, type, id);
    private createRemote(streamId, id, passive?);
    private getRemotes(streamId);
}
