var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Subject } from 'rxjs';
import { Channel, ChannelType } from '../../Channel';
import { log } from '../../misc/util';
import { dataChannelBuilder as proto } from '../../proto';
import { WebChannelState } from '../../WebChannelState';
import { Service } from '../Service';
import { Remote } from './Remote';
export var CONNECT_TIMEOUT = 7000;
var DataChannelBuilder = (function (_super) {
    __extends(DataChannelBuilder, _super);
    function DataChannelBuilder(wc, rtcConfiguration) {
        var _this = _super.call(this, DataChannelBuilder.SERVICE_ID, proto.Message) || this;
        _this.wc = wc;
        _this.allStreams = _super.prototype.useAllStreams.call(_this, wc, wc.signaling);
        _this.rtcConfiguration = rtcConfiguration;
        _this.channelsSubject = new Subject();
        _this.remotes = new Map();
        _this.remotes.set(_this.wc.STREAM_ID, new Map());
        _this.remotes.set(_this.wc.signaling.STREAM_ID, new Map());
        _this.allStreams.message.subscribe(function (_a) {
            var streamId = _a.streamId, senderId = _a.senderId, msg = _a.msg;
            var remote = _this.getRemotes(streamId).get(senderId) || _this.createRemote(streamId, senderId, true);
            remote.handleMessage(msg);
        });
        return _this;
    }
    DataChannelBuilder.prototype.onChannel = function () {
        return this.channelsSubject.asObservable();
    };
    DataChannelBuilder.prototype.connectInternal = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        log.webrtc(this.wc.myId + 'connectInternal');
                        _b = (_a = this.channelsSubject).next;
                        return [4, this.connect(this.wc.STREAM_ID, ChannelType.INTERNAL, id)];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        return [2];
                }
            });
        });
    };
    DataChannelBuilder.prototype.connectToJoin = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        log.webrtc(this.wc.myId + ' connectToJoin');
                        _b = (_a = this.channelsSubject).next;
                        return [4, this.connect(this.wc.signaling.STREAM_ID, ChannelType.JOINING, id)];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        return [2];
                }
            });
        });
    };
    DataChannelBuilder.prototype.connectToInvite = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        log.webrtc(this.wc.myId + 'connectToInvite');
                        _b = (_a = this.channelsSubject).next;
                        return [4, this.connect(this.wc.signaling.STREAM_ID, ChannelType.INVITED, id)];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        return [2];
                }
            });
        });
    };
    DataChannelBuilder.prototype.clean = function () {
        this.remotes.forEach(function (remotes) {
            return remotes.forEach(function (remote) {
                remote.onError(new Error('clean'));
                remote.clean();
            });
        });
    };
    DataChannelBuilder.prototype.connect = function (streamId, type, id) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var remote, dc_1, offer, channel, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        remote = this.createRemote(streamId, id);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        dc_1 = remote.pc.createDataChannel(this.wc.myId.toString());
                        return [4, remote.pc.createOffer()];
                    case 2:
                        offer = _a.sent();
                        return [4, remote.pc.setLocalDescription(offer)];
                    case 3:
                        _a.sent();
                        this.allStreams.sendOver(streamId, { offer: remote.pc.localDescription.sdp }, id);
                        remote.sdpIsSent();
                        return [4, new Promise(function (resolve, reject) {
                                remote.onError = function (err) { return reject(err); };
                                var timeout = setTimeout(function () {
                                    if (dc_1.readyState !== 'open') {
                                        reject(new Error("RTCDataChannel " + CONNECT_TIMEOUT + "ms connection timeout with '" + id + "'"));
                                    }
                                }, CONNECT_TIMEOUT);
                                var ch = new Channel(_this.wc, dc_1, type, id, remote.pc);
                                dc_1.onopen = function () {
                                    remote.pc.oniceconnectionstatechange = function () { };
                                    clearTimeout(timeout);
                                    log.webrtc(remote.peerToLog + ": RTCDataChannel with " + id + " has opened");
                                    if (type === ChannelType.INVITED) {
                                        ch.initialize();
                                    }
                                    resolve(ch);
                                };
                            })];
                    case 4:
                        channel = (_a.sent());
                        return [2, channel];
                    case 5:
                        err_1 = _a.sent();
                        log.webrtc('Error on initiator: ', err_1);
                        remote.clean();
                        throw err_1;
                    case 6: return [2];
                }
            });
        });
    };
    DataChannelBuilder.prototype.createRemote = function (streamId, id, passive) {
        var _this = this;
        if (passive === void 0) { passive = false; }
        log.webrtc(this.wc.myId + " New Remote object: ", id);
        var remote = new Remote(id, new global.RTCPeerConnection(this.rtcConfiguration), function (msg) { return _this.allStreams.sendOver(streamId, msg, id); }, this.getRemotes(streamId));
        if (passive) {
            remote.peerToLog = '----------- PASSIVE';
            remote.onError = function (err) {
                log.webrtc('Error on passive: ', err);
                remote.clean();
            };
            var dc_2;
            var timer_1 = setTimeout(function () {
                if (dc_2 === undefined || dc_2.readyState !== 'open') {
                    if (dc_2 !== undefined) {
                        dc_2.close();
                    }
                    remote.onError(new Error(CONNECT_TIMEOUT + "ms connection timeout"));
                }
            }, CONNECT_TIMEOUT);
            remote.onDataChannel = function (dataChannel) {
                dc_2 = dataChannel;
                var peerId = Number.parseInt(dc_2.label, 10);
                var type;
                if (streamId === _this.wc.STREAM_ID) {
                    type = ChannelType.INTERNAL;
                }
                else if (_this.wc.state === WebChannelState.JOINED) {
                    type = ChannelType.INVITED;
                }
                else {
                    type = ChannelType.JOINING;
                }
                var channel = new Channel(_this.wc, dc_2, type, peerId, remote.pc);
                dc_2.onopen = function () {
                    clearTimeout(timer_1);
                    log.webrtc(remote.peerToLog + ": RTCDataChannel with " + channel.id + " has opened");
                    _this.channelsSubject.next(channel);
                };
            };
        }
        return remote;
    };
    DataChannelBuilder.prototype.getRemotes = function (streamId) {
        return this.remotes.get(streamId);
    };
    DataChannelBuilder.SERVICE_ID = 7431;
    return DataChannelBuilder;
}(Service));
export { DataChannelBuilder };
//# sourceMappingURL=DataChannelBuilder.js.map