import { dataChannelBuilder as proto } from '../../proto';
export declare class Remote {
    readonly id: number;
    readonly pc: RTCPeerConnection;
    peerToLog: string;
    private readonly candidates;
    private readonly send;
    private readonly remotes;
    private isSDPSent;
    private _onError;
    constructor(id: number, pc: RTCPeerConnection, send: (msg: proto.IMessage | undefined) => void, remotes: Map<number, Remote>);
    onError: (err: Error) => void;
    onDataChannel: (dc: RTCDataChannel) => void;
    sdpIsSent(): void;
    clean(): void;
    handleMessage(msg: proto.Message): void;
    private log(msg, obj?);
}
